#include "Cat.h"
#include "stdlib.h"
#include "math.h"

double rand_value()
{
	return (rand()/double(RAND_MAX));
}

CCat::CCat()
{
	status=ST_ALIVE;
	hungry_level=INIT_HUNGRY_LVL;
	power_level=INIT_POWER_LVL;
	age=0;
}

CCat::CCat(CCat mother, CCat father)
{
	status=ST_ALIVE;
	hungry_level=INIT_HUNGRY_LVL;
	age=0;

	double mother_coef,father_coef;
	int m_sign=1,f_sign=1;

	if ( rand_value()>0.5 ) 
		m_sign=-1; 

	if ( rand_value()>0.5 ) 
		f_sign=-1; 

	mother_coef=1+m_sign*rand_value()*0.5;
	father_coef=1+f_sign*rand_value()*0.5;

	double t; 
	t=rand_value();
	power_level=t*mother_coef*mother.power_level+(1-t)*father_coef*father.power_level;
}

void CCat::Eat(int mouses)
{
	hungry_level+=mouses*0.5;
	if (hungry_level>MAX_HUNGRY_LVL)
	{
		status=ST_DEAD;
		power_level=0;
		return;
	}

}

void CCat::Next_BirthDay()
{
	if (! isAlive()) return;

	age++;
	if (age>MAX_AGE)
	{
		status=ST_DEAD;
		power_level=0;
		return;
	}

	if (age<MAX_AGE*0.333) power_level*=1.5;
	else
	if (age<MAX_AGE*0.666);
	else
	power_level*=0.66666;
}

int CCat::isAlive()
{
	return (status==ST_ALIVE);
}

double CCat::MaxSpeed()
{
	return log(1+power_level); 
}